from random import randint
from dictutil import *

## Task 1
def movie_review(name):
    """
    Input: the name of a movie
    Output: a string (one of the review options), selected at random using randint
    """
    review_options = ["See it!", "A gem!", "Ideological claptrap!"]
    #return ...
    return review_options[randint(0,len(review_options)-1)]


## Tasks 2 and 3 are in dictutil.py

## Task 4    
def makeInverseIndex(strlist):
    """
    Input: a list of documents as strings
    Output: a dictionary that maps each word in any document to the set consisting of the
            document ids (ie, the index in the strlist) for all documents containing the word.

    Note that to test your function, you are welcome to use the files stories_small.txt
      or stories_big.txt included in the download.
    """
    #return ...
    D = { w:set() for i in range(len(strlist)) for w in strlist[i].split() }
    { w:D[w].add(n) if w in D.keys() else 'NA' for n in range(len(strlist)) for w in strlist[n].split() }
    return D

    

## Task 5
def orSearch(inverseIndex, query):
    """
    Input: an inverse index, as created by makeInverseIndex, and a list of words to query
    Output: the set of document ids that contain _any_ of the specified words
    """
    #return ...
    #D = set()
    #{D.add(n) for k in query for n in inverseIndex[k] }
    #return D
    return { n for w in query if w in inverseIndex.keys() for n in inverseIndex[w] }

## Task 6
def andSearch(inverseIndex, query):
    """
    Input: an inverse index, as created by makeInverseIndex, and a list of words to query
    Output: the set of all document ids that contain _all_ of the specified words
    """
    #return ... 
    #L = [] 
    #for i in range(len(query)):
    #  if query[i] in inverseIndex.keys():
    #    L.append(inverseIndex[query[i]])
    #{ n for i in range(len(S)) for n in S[i] } # does an or search
    L = dict2list(inverseIndex, query)    
    return set.intersection(*L)  
